﻿//---state-plus---作:1-239--------------
//
//【概要】
//・ステートに対して回避率を設定
//・絶対値・上限値・相手のパラメータにより命中を増減可能に
//
//【使用方法】
//突っ込んでカスパラを設定
//
//ユニット…{stateGuardNo} 指定したナンバーの配列の耐性値を減算します
//ステート…{DefaultPercent} 絶対値を可算します
//	　…{reduse}{value} 対象の{reduse}の番号のステを{value}倍した値を減算します 
//	　…{maxPercent} ステートの命中上限
//	　…{minPercent} ステートの命中下限
//
//設定例
//・発動率・技*4 {DefaultPercent:60}
//　→60+(技*4)となる
//
//・発動率・60 {reduse:7,value:10}
//　→60-(対象魔防*10)となる
//
//・発動率・技*20 {maxPercent:80}
//　→技*20(最大80%)となる
//
//---------------------------------------------
Probability.getreduse = function(unit,state) {
//=======ここにステートの耐性値を入力します==============

	var ary0 = [15];
	var ary1 = [100,40,25];
	var ary2 = [100,40,25];
	var ary3 = [100,40,25];

	var ary = [ary0,ary1,ary2,ary3];


//=======設定ここまで======================================

	var value = 0;
	var reduse = unit.custom.stateGuardNo;
	var ID = state.getID();
	if(typeof reduse == 'number'){
	value = ary[reduse][ID];
	if(typeof value !== 'number'){
	value = 0;}}

	return value;
}

StateControl.checkStateInvocation = function(active, passive, obj,staff) {
	var stateInvocation = obj.getStateInvocation();
	var state = stateInvocation.getState();

	if(state !== null){
	if (this.isStateBlocked(passive, state)) {
		// ステートを無効にできたためnullを返す
		return null;
	}
	if (Probability.getcustomProbability(active, stateInvocation.getInvocationType(), stateInvocation.getInvocationValue(),state,passive)) {
	// 発動条件を満たした場合はステートを返す
	return state;
	}
	}
	return null;
}

Probability.getcustomProbability = function(unit, type, value,state,enemy) {
	var result = 0;
	var Guard = 0;

	if (type === InvocationType.ABSOLUTE) {
		result = value;}
	else if (type === InvocationType.LV) {
		result = unit.getLv() * value;}
	else {
	if (root.getUserExtension().isSkillInvocationBonusEnabled()) {
		result = ParamBonus.getBonus(unit, type) * value;
	}else {
		result = unit.getParamValue(type) * value;
	}}

	//絶対値の可算
	if(typeof state.custom.DefaultPercent == 'number'){result += state.custom.DefaultPercent;}

	//相手のパラメータ代入
	if(typeof state.custom.reduse == 'number'){
	var index = state.custom.reduse;
	var VL = state.custom.value;
	if (root.getUserExtension().isSkillInvocationBonusEnabled()) {
	Guard += ParamBonus.getBonus(enemy, index) * VL;
	}else {
	Guard += enemy.getParamValue(index) * VL;
	}}

	Guard += Probability.getreduse(enemy,state);

	if(result >= 100){result = 100;}

	result -= Guard;

	//上限値の処理
	if(typeof state.custom.maxPercent == 'number'){
	if(result >= state.custom.maxPercent){result = state.custom.maxPercent;}}
	if(typeof state.custom.minPercent == 'number'){
	if(result <= state.custom.minPercent){result = state.custom.minPercent;}}

	root.log('ステート付加率_'+result+' %');

	return Probability.getProbability(result);
}

StateItemInfo._drawValue = function(x, y) {
	var stateInvocation = this._item.getStateInfo().getStateInvocation();
	var state = stateInvocation.getState();
	var text = InvocationRenderer.getstateText(stateInvocation.getInvocationValue(), stateInvocation.getInvocationType());
	var textui = this.getWindowTextUI();
	var color = textui.getColor();
	var font = textui.getFont();

	//絶対値の可算
	if(typeof state.custom.DefaultPercent == 'number'){text = state.custom.DefaultPercent+'+'+text;}
	//相手のステ
	if(typeof state.custom.reduse == 'number'){var Name = ParamGroup.getParameterName(state.custom.reduse);
	text = text+'-('+Name+'x'+state.custom.value+')';}

	TextRenderer.drawKeywordText(x, y, state.getName() + ' ' + text+'%', -1, color, font);
}

InvocationRenderer.getstateText = function(value, type) {
		var text = '';
		
		if (type === InvocationType.ABSOLUTE) {
			text = value;
		}
		else {
			if (type === InvocationType.LV) {
				text = StringTable.Status_Level;
			}
			else {
				text = ParamGroup.getParameterName(ParamGroup.getParameterIndexFromType(type));
			}
		
			text = '(' + text;
			if (value > 1) {
				text += '' + StringTable.SignWord_Multiple + '' + value;
			}
			text += ')';
		}
		
	return text;
}

AttackEvaluator.HitCritical._checkStateAttack = function(virtualActive, virtualPassive, attackEntry) {
	var i, count, skill, state;
	var arr = SkillControl.getDirectSkillArray(virtualActive.unitSelf, SkillType.STATEATTACK, '');
		
	// スキルのステート発動を確認する
	count = arr.length;
	for (i = 0; i < count; i++) {
		skill = arr[i].skill;
		state = this._getState(skill);
			
		if (StateControl.isStateBlocked(virtualPassive.unitSelf, state)) {
		// ステートは無効対象であるため発動しない
		continue;}

		if (!Probability.getcustomProbability(virtualActive.unitSelf, skill.getInvocationType(), skill.getInvocationValue(),state,virtualPassive.unitSelf)) {
		// 発動条件を満たした場合はステートを返す
		continue;}

		if (!SkillRandomizer.isSkillInvoked(virtualActive.unitSelf, virtualPassive.unitSelf, skill)) {
		// スキルの発動率が成立しなかった
		continue;}
			
		// Active側はスキルが発動したからskillArrayActiveに追加
		attackEntry.skillArrayActive.push(skill);
			
		// Passive側はステートを受けるからstateArrayPassiveに追加
		attackEntry.stateArrayPassive.push(state);
			
		// 戦闘全体に渡ってステートを記録する
		virtualPassive.stateArray.push(state);}
		
		// 武器のステート発動を確認する
		state = StateControl.checkStateInvocation(virtualActive.unitSelf, virtualPassive.unitSelf, virtualActive.weapon);
		if (state !== null) {
		attackEntry.stateArrayPassive.push(state);
		virtualPassive.stateArray.push(state);}
}

ItemSentence.AdditionState.drawItemSentence = function(x, y, item) {
	var stateInvocation = item.getStateInvocation();
	var state = stateInvocation.getState();
	var text, stateInvocation,state;
	var textui = root.queryTextUI('default_window');
	var color = textui.getColor();
	var font = textui.getFont();
		
	if (!this._isState(item)) {return;}

	//text = StringTable.State_Addition;
	//ItemInfoRenderer.drawKeyword(x, y, text);
	//x += ItemInfoRenderer.getSpaceX()/2;
	text = InvocationRenderer.getstateText(stateInvocation.getInvocationValue(), stateInvocation.getInvocationType());

	//絶対値の可算
	if(typeof state.custom.DefaultPercent == 'number'){text = state.custom.DefaultPercent+'+'+text;}
	//相手のステ
	if(typeof state.custom.reduse == 'number'){var Name = ParamGroup.getParameterName(state.custom.reduse);
	text = text+'-('+Name+'x'+state.custom.value+')';}

	TextRenderer.drawKeywordText(x, y, state.getName() + ' ' + text+'%', -1, color, font);
}